//=============================================================================
// this game sucks.
//=============================================================================



//=============================================================================
// SAVE MENU
//=============================================================================
Game_Actor.prototype.faceSaveLoad = function() {
    var actor = this.actor();
    if (actor.meta.BattleStatusFaceName) {
      return actor.meta.BattleStatusFaceName.trim();
    } else {
      return "01_FA_OMORI_BATTLE";
    };
  };

// Fixes bug with saveloadplus not properly loading new mod faces
var old_Scene_OmoriFile_prototype_loadReservedBitmaps = Scene_OmoriFile.prototype.loadReservedBitmaps;
Scene_OmoriFile.prototype.loadReservedBitmaps = function() {
  old_Scene_OmoriFile_prototype_loadReservedBitmaps.call(this);
  ImageManager.reserveFace("01_HW_PLAYER_BATTLE", 0, this._imageReservationId);
  ImageManager.reserveFace("LUCILLE_BATTLE", 0, this._imageReservationId);
  ImageManager.reserveFace("MARINA_BATTLE", 0, this._imageReservationId);
  ImageManager.reserveFace("MAKOTO_BATTLE", 0, this._imageReservationId);
};

//=============================================================================
// BATTLE
//=============================================================================

old_Game_Action_apply = Game_Action.prototype.apply;
old_Window_BattleLog_displayActionResults = Window_BattleLog.prototype.displayActionResults;

Game_Action.prototype.apply = function(target) {
  // Run Original Function
  old_Game_Action_apply.call(this, target);

  let result = target.result();
  // Check iff hit
  let hit = result.isHit();

  // If Hit
  if (hit) {
    // Get Element Rate
    let elementRate = this.calcElementRate(target);

    // Set elemental results
    result.elementStrong = elementRate > 1;
    result.elementWeak = elementRate < 1;

    console.log(this.subject().name(),  elementRate);
  };


  // If Target is an enemy
  if (target.isEnemy()) {
    // Get Item
    let item = this.item();
    // If result was a hit
    if (hit) {
      // If scanning enemy
      if (item && item.meta.ScanEnemy && target.canScan()) {
        // Scan Enemy
        $gameParty.addScannedEnemy(target.enemyId());
      };
      // if crit OR moving attack 
      if (result.critical || result.elementStrong) {
        $gameParty.stressEnergyCount++;
      };
    };
  };
};

BattleManager.getActorInputOrder = function() {
  let members = $gameParty.members();

  // separate members into an array of arrays each containing only their index agility, and dead status
  let list = members.map((el, index) => [index, el.agi, el.isAlive() && el.isBattleMember()])
  // sort by agility (sort is performed in place so no need to reassign list)
  list.sort((a, b) => b[1] > a[1])
  // remove dead members
  list = list.filter(_ => _[2])
  // reduce array to just the indexes
  return list.map(_ => _[0])
};


Window_BattleLog.prototype.displayActionResults = function(subject, target) {
  old_Window_BattleLog_displayActionResults.call(this, subject, target);
  if (target._extDmg > 0) {
    this.push("addText",'...and takes an extra ' + target._extDmg + ' damage!');
    this.push("waitForNewLine");
  };
  target._extDmg = 0;
};
